﻿Imports Microsoft.Win32

Public Class Form1

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        If MainWindow.intFormat = 0 Then
            rbJpeg.Checked = True
        Else
            rbPng.Checked = True
        End If

        ' クリップボード読み出しディレイ
        Me.ComboBoxDelay.SelectedIndex = MainWindow.intDelay

        ' 簡易設定
        Me.txtFileNameBase.Text = MainWindow.strFileName

        Me.chkUseNumber.Checked = MainWindow.bAddNumber
        Me.txtNumber.Enabled = MainWindow.bAddNumber

        Me.chkDateTime.Checked = MainWindow.bAddDateTime
        Me.txtNumber.Value = MainWindow.intNumber

        ' 詳細設定
        Me.txtFileNameFormat.Text = MainWindow.strFileName2
        Me.txtNumber2.Value = MainWindow.intNumber

        ' 簡易指定か詳細指定か？
        If MainWindow.bolShosai = False Then
            TabControl1.SelectedIndex = 0
        Else
            TabControl1.SelectedIndex = 1
        End If

        ' 保存ダイアログは１つしか開かないようにする
        Me.chkSingle.Checked = MainWindow.bolSingle

        ' 音とアイコン変化
        Me.chkSound.Checked = MainWindow.bolSound

        ' テキストと認識されるものも処理対象
        Me.chkDoText.Checked = MainWindow.bolDoText

        ' グレースケールに変換
        Me.chkGrayScale.Checked = MainWindow.bolGrayScale

        ' 回転と反転
        Me.cmbRotateFlip.SelectedIndex = MainWindow.intRotateFlip

        ' 拡大・縮小
        Select Case (MainWindow.intZoomKind)
            Case 1
                rbPixel1.Checked = True

            Case 2
                rbPixel2.Checked = True

            Case Else
                rbPercent.Checked = True
        End Select
        textboxWidth.Value = MainWindow.intZoomWidth
        textboxHeight.Value = MainWindow.intZoomHeight

        ' 補完方式
        cmbInterpolationMode.SelectedIndex = MainWindow.intInterpolationMode

        ' JPEG画質
        numJPEGQuality.Value = MainWindow.intJpegQuality

        ' 日付時刻の埋め込み
        chkDrawDateTime.Checked = MainWindow.bolDrawDT_DateTime   ' 画像に日付時刻を埋め込む
        cbDrawDT_Place.SelectedIndex = MainWindow.intDrawDT_Place ' 位置指定
        txtDrawDT_Format.Text = MainWindow.strDrawDT_Format       ' 書式

        ' フォントの生成
        If MainWindow.strDrawDT_FontName <> "" Then
            Dim newStyle As System.Drawing.FontStyle = FontStyle.Regular
            If MainWindow.bolDrawDT_FontBold Then
                newStyle = newStyle Or FontStyle.Bold
            End If
            If MainWindow.bolDrawDT_FontItalic Then
                newStyle = newStyle Or FontStyle.Italic
            End If
            If MainWindow.bolDrawDT_FontUnderline Then
                newStyle = newStyle Or FontStyle.Underline
            End If
            If MainWindow.bolDrawDT_FontStrikeout Then
                newStyle = newStyle Or FontStyle.Strikeout
            End If
            FontDialog1.Font = New Font(MainWindow.strDrawDT_FontName, MainWindow.intDrawDT_FontSize, newStyle)

            FontDialog1.Color = Color.FromArgb(MainWindow.intDrawDT_FontColor)     ' 色
        Else
            ' フォントが未設定の場合はMainWindowが採用しているフォントを仮採用する。文字色は白。
            FontDialog1.Font = MainWindow.Font
            FontDialog1.Color = Color.White
        End If

        chkDrawDT_BackFillColor.Checked = MainWindow.bolDrawDT_BackFillColor ' 背景色の塗り潰し
        ColorDialog1.Color = Color.FromArgb(MainWindow.intDrawDT_BGColor)    ' 背景色

        ' 日付時刻埋め込みに関するチェックボックスとダイアログ項目有効無効の設定
        chkDrawDateTime_CheckedChanged(Nothing, Nothing)

    End Sub

    ' 数値入力項目のチェック
    Private Function checkNumber(ByVal txtMean As String, ByVal txtValue As String, ByVal intMinValue As Integer, ByVal intMaxValue As Integer) As Boolean
        Try
            Dim intTemp As Integer = Integer.Parse(txtValue)
            If (intTemp < intMinValue OrElse intMaxValue < intTemp) Then
                MessageBox.Show(txtMean + "には" & intMinValue & "～" & intMaxValue & "を指定してください。", "設定", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return False
            End If
        Catch ex As System.FormatException
            MessageBox.Show(txtMean + "には" & intMinValue & "～" & intMaxValue & "を指定してください。", "設定", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return False
        Catch ex As Exception
            ErrorDialog.ShowMessage(txtMean + "には" & intMinValue & "～" & intMaxValue & "を指定してください。", ex.ToString(), "設定")
            Return False
        End Try

        Return True
    End Function

    Private Function fromTF(ByVal b As Boolean) As Integer
        If b Then
            Return 1
        Else
            Return 0
        End If
    End Function


    Private Sub btnOK_Click(sender As System.Object, e As System.EventArgs) Handles btnOK.Click
        ' 設定をレジストリに保存してから、設定ダイアログを閉じる

        ' ■まずは入力検定
        If TabControl1.SelectedIndex = 0 Then
            ' 簡易設定の場合
            If Me.txtFileNameBase.Text = "" Then
                MessageBox.Show("「出力先のフォルダ名＋ファイル名（拡張子を除く）の基礎部分」は、空にできません。", "設定", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If

            ' 番号として数値が入力されているか
            If checkNumber("連番の次番号", Me.txtNumber.Text, 0, 99999999) = False Then
                Return
            End If

            Try
                ' フォルダの存在確認
                Dim strDirName As String = System.IO.Path.GetDirectoryName(Me.txtFileNameBase.Text)
                If Not System.IO.Directory.Exists(strDirName) Then
                    If DialogResult.Cancel = MessageBox.Show("フォルダ " + strDirName + " は存在しません。設定を続行してもよろしいですか?", "設定", MessageBoxButtons.OKCancel, MessageBoxIcon.Question) Then
                        Return
                    End If
                End If
            Catch ex As System.ArgumentException
                MessageBox.Show("「出力先のフォルダ名＋ファイル名の基礎部分」にフォルダ名として指定できない文字が含まれています。入力内容を見直してください。", "設定", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            Catch ex As Exception
                ErrorDialog.ShowMessage("「出力先のフォルダ名＋ファイル名の基礎部分」が不正です。", ex.ToString(), "設定")
                Return
            End Try
        Else
            ' 詳細設定の場合
            If Me.txtFileNameFormat.Text = "" Then
                MessageBox.Show("「出力先のフォルダ名＋ファイル名のフォーマット」は、空にできません。", "設定", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If

            ' 番号として数値が入力されているか
            If checkNumber("連番の次番号", Me.txtNumber2.Text, 0, 99999999) = False Then
                Return
            End If

            Try
                ' フォルダの存在確認
                Dim strDirName As String = System.IO.Path.GetDirectoryName(Me.txtFileNameBase.Text)
                If Not System.IO.Directory.Exists(strDirName) Then
                    ' フォルダの存在確認については、年月日や連番など不定なモノが入る可能性がアリ
                    ' とりあえずここでは存在を確認するフリだけ実施し、不正な文字を利用していた場合の
                    ' 例外の発生を誘う。
                End If
            Catch ex As System.ArgumentException
                MessageBox.Show("「出力先のフォルダ名＋ファイル名のフォーマット」にフォルダ名として指定できない文字が含まれています。入力内容を見直してください。", "設定", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            Catch ex As Exception
                ErrorDialog.ShowMessage("「出力先のフォルダ名＋ファイル名のフォーマット」が不正です。", ex.ToString(), "設定")
                Return
            End Try

        End If

        ' 拡大縮小幅として数値が入力されているか
        If checkNumber("幅", Me.textboxWidth.Text, 1, 9999) = False Then
            Return
        End If

        ' 拡大縮小高として数値が入力されているか
        If checkNumber("高さ", Me.textboxHeight.Text, 1, 9999) = False Then
            Return
        End If

        ' 画質
        If checkNumber("JPEG画質", Me.numJPEGQuality.Text, 1, 100) = False Then
            Return
        End If

        ' ここまではロールバック
        ' ------------------------
        ' ここから書き込みコミット
        ' ■ダイアログ内容の読み出しとコミット

        ' 連番制御
        If TabControl1.SelectedIndex = 0 Then
            MainWindow.intNumber = CInt(Me.txtNumber.Value)
        Else
            MainWindow.intNumber = CInt(Me.txtNumber2.Value)
        End If

        ' まずはいったん、ダイアログから設定値を読み出す
        If rbJpeg.Checked Then
            MainWindow.intFormat = 0 ' Jpeg
        Else
            MainWindow.intFormat = 1 ' Png
        End If

        ' 保存ダイアログは１つしか開かないようにする
        MainWindow.bolSingle = chkSingle.Checked

        ' 音とアイコン変化
        MainWindow.bolSound = chkSound.Checked

        ' テキストと認識されるものも処理対象
        MainWindow.bolDoText = chkDoText.Checked

        ' グレースケールに変換する
        MainWindow.bolGrayScale = chkGrayScale.Checked

        ' 回転と反転
        MainWindow.intRotateFlip = cmbRotateFlip.SelectedIndex

        ' 拡大・縮小
        If rbPercent.Checked Then
            MainWindow.intZoomKind = 0
        ElseIf rbPixel1.Checked Then
            MainWindow.intZoomKind = 1
        Else
            MainWindow.intZoomKind = 2
        End If

        MainWindow.intZoomWidth = CInt(Me.textboxWidth.Value)
        MainWindow.intZoomHeight = CInt(Me.textboxHeight.Value)

        ' 補完方式
        MainWindow.intInterpolationMode = Me.cmbInterpolationMode.SelectedIndex

        ' JPEG画質
        MainWindow.intJpegQuality = CInt(Me.numJPEGQuality.Value)

        ' クリップボード読み出しディレイ
        MainWindow.intDelay = ComboBoxDelay.SelectedIndex

        ' 簡易指定か詳細指定か
        If TabControl1.SelectedIndex = 1 Then
            MainWindow.bolShosai = True
        Else
            MainWindow.bolShosai = False
        End If

        ' [簡易指定の場合]
        MainWindow.strFileName = Me.txtFileNameBase.Text
        MainWindow.bAddDateTime = chkDateTime.Checked
        MainWindow.bAddNumber = chkUseNumber.Checked

        ' [詳細指定の場合]
        MainWindow.strFileName2 = Me.txtFileNameFormat.Text

        ' [日付時刻の埋め込み]
        MainWindow.bolDrawDT_DateTime = chkDrawDateTime.Checked   ' 画像に日付時刻を埋め込む
        MainWindow.intDrawDT_Place = cbDrawDT_Place.SelectedIndex ' 位置指定
        MainWindow.strDrawDT_Format = txtDrawDT_Format.Text       ' 書式
        MainWindow.strDrawDT_FontName = FontDialog1.Font.Name           ' フォント名
        MainWindow.intDrawDT_FontSize = CInt(FontDialog1.Font.Size)     ' フォントサイズ
        MainWindow.bolDrawDT_FontBold = FontDialog1.Font.Bold           ' 太字指定
        MainWindow.bolDrawDT_FontItalic = FontDialog1.Font.Italic       ' 斜体指定
        MainWindow.bolDrawDT_FontUnderline = FontDialog1.Font.Underline ' 下線
        MainWindow.bolDrawDT_FontStrikeout = FontDialog1.Font.Strikeout ' 取消線
        MainWindow.intDrawDT_FontColor = FontDialog1.Color.ToArgb       ' フォント色
        MainWindow.bolDrawDT_BackFillColor = chkDrawDT_BackFillColor.Checked ' 背景色の塗り潰し
        MainWindow.intDrawDT_BGColor = ColorDialog1.Color.ToArgb             ' 背景色

        ' 日付時刻埋め込みに関するチェックボックスとダイアログ項目有効無効の設定
        chkDrawDateTime_CheckedChanged(Nothing, Nothing)


        Try
            ' レジストリキーのパスを指定してレジストリを開く
            Dim rKey As RegistryKey = Registry.CurrentUser.CreateSubKey(MainWindow.strRegName)
            If Not rKey Is Nothing Then
                ' レジストリの値を取得
                With rKey
                    ' 簡易指定か詳細指定か
                    .SetValue("Shosai", fromTF(MainWindow.bolShosai))

                    ' ファイル名のベース
                    .SetValue("FileNameBase", MainWindow.strFileName)

                    ' ファイル名のフォーマット
                    .SetValue("FileNameFormat", MainWindow.strFileName2)

                    ' 日付時刻を付与する
                    .SetValue("AddDateTime", fromTF(MainWindow.bAddDateTime))

                    ' 連番を付けるか
                    .SetValue("AddNumber", fromTF(MainWindow.bAddNumber))

                    ' 保存形式
                    .SetValue("SaveFormat", MainWindow.intFormat)

                    ' 保存ダイアログは1つしか開かないようにする
                    .SetValue("Single", fromTF(MainWindow.bolSingle))

                    ' 音とアイコン変化
                    .SetValue("Sound", fromTF(MainWindow.bolSound))

                    ' テキストと認識されるものも処理対象
                    .SetValue("DoText", fromTF(MainWindow.bolDoText))

                    ' グレースケールに変換
                    .SetValue("GrayScale", fromTF(MainWindow.bolGrayScale))

                    ' 回転と反転
                    .SetValue("RotateFlip", MainWindow.intRotateFlip)

                    ' 拡大・縮小
                    .SetValue("ZoomKind", MainWindow.intZoomKind)
                    .SetValue("ZoomWidth", MainWindow.intZoomWidth)
                    .SetValue("ZoomHeight", MainWindow.intZoomHeight)

                    ' 補完モード
                    .SetValue("InterpolationMode", MainWindow.intInterpolationMode)

                    ' JPEG画質
                    .SetValue("JpegQuality", MainWindow.intJpegQuality)

                    ' クリップボード読み出しディレイ
                    .SetValue("Delay", MainWindow.intDelay)

                    ' 日付時刻の埋め込み
                    .SetValue("bolDrawDT_DateTime", fromTF(MainWindow.bolDrawDT_DateTime))
                    .SetValue("intDrawDT_Place", MainWindow.intDrawDT_Place)
                    .SetValue("strDrawDT_Format", MainWindow.strDrawDT_Format)
                    .SetValue("strDrawDT_FontName", MainWindow.strDrawDT_FontName)
                    .SetValue("intDrawDT_FontSize", MainWindow.intDrawDT_FontSize)
                    .SetValue("bolDrawDT_FontBold", fromTF(MainWindow.bolDrawDT_FontBold))
                    .SetValue("bolDrawDT_FontItalic", fromTF(MainWindow.bolDrawDT_FontItalic))
                    .SetValue("bolDrawDT_FontUnderline", fromTF(MainWindow.bolDrawDT_FontUnderline))
                    .SetValue("bolDrawDT_FontStrikeout", fromTF(MainWindow.bolDrawDT_FontStrikeout))
                    .SetValue("intDrawDT_FontColor", MainWindow.intDrawDT_FontColor)
                    .SetValue("bolDrawDT_BackFillColor", fromTF(MainWindow.bolDrawDT_BackFillColor))
                    .SetValue("intDrawDT_BGColor", MainWindow.intDrawDT_BGColor)

                    .Close()    ' 開いたレジストリキーを閉じる
                End With
            End If
        Catch ex As Exception
            ' レジストリへ書き込み失敗
            ErrorDialog.ShowMessage("レジストリへ設定値を書き込めません。", ex.ToString(), "設定")
        End Try

        Me.Visible = False

        If MainWindow.bFirstBoot Then
            MainWindow.bFirstBoot = False
        End If

        Me.Close()

    End Sub

    Private Sub btnCancel_Click(sender As System.Object, e As System.EventArgs) Handles btnCancel.Click
        ' 設定をレジストリに保存しないで、設定ダイアログを閉じる
        Me.Close()

        'bFirstBootが設定されていたとしても、クリアせずにダイアログを閉じる。これにより、呼び出し元にキャンセルを伝える仕組み
        'If MainWindow.bFirstBoot Then
        'End If
    End Sub

    ' 参照ボタン押下（簡易）
    Private Sub btnBrowse_Click(sender As System.Object, e As System.EventArgs) Handles btnBrowse.Click
        FolderBrowserDialog1.SelectedPath = Me.txtFileNameBase.Text

        If FolderBrowserDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Me.txtFileNameBase.Text = FolderBrowserDialog1.SelectedPath

            ' 最後が \ で終わっていなかったら \ を付ける
            If Me.txtFileNameBase.Text.Length >= 1 Then
                If Me.txtFileNameBase.Text.Chars(Me.txtFileNameBase.Text.Length - 1) <> "\"c Then
                    Me.txtFileNameBase.Text += "\"
                End If
            End If

        End If
    End Sub

    ' 参照ボタン押下（詳細）
    Private Sub btnBrowse2_Click(sender As System.Object, e As System.EventArgs) Handles btnBrowse2.Click
        FolderBrowserDialog1.SelectedPath = Me.txtFileNameFormat.Text

        If FolderBrowserDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Me.txtFileNameFormat.Text = FolderBrowserDialog1.SelectedPath

            ' 最後が \ で終わっていなかったら \ を付ける
            If Me.txtFileNameFormat.Text.Length >= 1 Then
                If Me.txtFileNameFormat.Text.Chars(Me.txtFileNameFormat.Text.Length - 1) <> "\"c Then
                    Me.txtFileNameFormat.Text += "\"
                End If
            End If

        End If
    End Sub

    Private Sub chkUseNumber_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkUseNumber.CheckedChanged
        ' チェックボックスのON/OFFと番号入力欄の活性状態は連動する
        txtNumber.Enabled = chkUseNumber.Checked
    End Sub

    Private Sub Form1_Shown(sender As System.Object, e As System.EventArgs) Handles MyBase.Shown
        ' 最初は必ず最前面に表示されるように
        Me.TopMost = True
        Me.Refresh()
        Me.TopMost = False
    End Sub

    Private Sub rbPercent_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbPercent.CheckedChanged
        If rbPercent.Checked Then
            lblWidthUnit.Text = "%"
            lblHeightUnit.Text = "%"
        Else
            lblWidthUnit.Text = "px"
            lblHeightUnit.Text = "px"
        End If
    End Sub

    Private Sub btnHelp_Click(sender As System.Object, e As System.EventArgs) Handles btnHelp.Click
        MainWindow.miHelp_Click(sender, e)
    End Sub

    ' 日付時刻埋め込みのチェックボックスとダイアログ項目有効化の対応
    Private Sub chkDrawDateTime_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkDrawDateTime.CheckedChanged, chkDrawDT_BackFillColor.CheckedChanged
        pnlDrawDT.Enabled = chkDrawDateTime.Checked
        btnDrawDT_BGColor.Enabled = chkDrawDT_BackFillColor.Checked
    End Sub

    ' [日付時刻埋め込み]フォントの指定
    Private Sub btnDrawDT_Font_Click(sender As System.Object, e As System.EventArgs) Handles btnDrawDT_Font.Click
        FontDialog1.ShowDialog()
    End Sub

    ' [日付時刻埋め込み]背景色の指定
    Private Sub btnDrawDT_BGColor_Click(sender As System.Object, e As System.EventArgs) Handles btnDrawDT_BGColor.Click
        ColorDialog1.ShowDialog()
    End Sub
End Class
